/*
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2009 - Jorge CARDONA
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#ifndef __INTEGRALS_HPP__
#define __INTEGRALS_HPP__

#include "ginac/ginac.h"
using namespace GiNaC;
using namespace std;

lst HalfExtendedEuclidean(ex A, ex B, symbol x)
{
    ex A_1 = 1;
    ex B_1 = 0;
    
    ex Q, R, R_1;
    while (not B.is_zero())
    {
        Q = quo(A,B,x);
        R = rem(Q,B,x);
        
        A = B;
        B = R;
        
        R_1 = A_1 - Q * B_1;
        A_1 = B_1;
        B_1 = R1;
    }
    
    lst(A_1, A);
}

ex HalfExtendedEuclidean(ex A, ex B, ex C, symbol x)
{
    lst S_G = HalfExtendedEuclidean(ex A, ex B, symbol x);
    ex S = S_G[0]; ex G = S_G[1];
    
    ex Q = quo(C,G,x);
    ex R = rem(C,G,x);
    
    if (not R.is_zero())
        throw logic_error("C is not in the ideal generated by A and B.");
    
    ex S = Q * S;
    
    if ((not S.is_zero()) and S.degree(x) >= B.degree(x))
    {
        R = rem(S,B,x);
        S = R;
    }

    return S;
}

lst ExtendedEuclidean(ex A, ex B, ex C, symbol x)
{
    ex S = HalfExtendedEuclidean(A,B,C);
    R = quo(C - S * A, B , x);

    return lst(S, R)
}

lst HermiteReduce(ex A, ex D, symbol x)
{
    ex g        = 0;
    ex D_minus  = gcd(D,D.diff(x));
    ex D_star   = quo(D, D_minus,x);
    
    ex D_minus_2, D_minus_star, B, C;
    while(D_minus.degree(x) > 0)
    {
        D_minus_2       = gcd(D_minus, D_minus.diff(x));
        D_minus_star    = quo(D_minus, D_minus_2, x);
        lst B_C         = ExtendedEuclidean(quo(-D_star * D_minus.diff(x), D_minus,x), D_minus_star, A, x);
        B = B_C[0]; C = B_C[1];
        A               = C - quo(B.diff(x) * D_star, D_minus_star, x);
        g               = g + quo(B, D_minus,x);
        D_minus         = D_minus_2;
    }
    
    return lst(g, A, D_star);
}


#endif /*  __INTEGRALS_HPP__ */
